import java.util.*;

public class BankRunner implements Runnable
{
	BankAccount acc;
	Thread[] threads;
	final static int TIMES=100000;
	
	public BankRunner(BankAccount account,int threadNum)
	{
		acc=account;
		threads=new Thread[threadNum];
	}
	
	public void initThreads()
	{
		for(int i=0;i<threads.length;i++)
		{
			threads[i]=new Thread(this);
			threads[i].start();
		}
	}
	
	public void waitForThreads()
	{
		for(int i=0;i<threads.length;i++) try{threads[i].join();}catch(Exception e){}
	}
	
	public void run()
	{
		Random r=new Random();
		try
		{
			for(int i=0;i<TIMES;i++)
			{
				int x=r.nextInt(1000);
				acc.deposit((long)x);
				acc.withdraw((long)x);
			}
		}
		catch(Exception e){System.err.println("Exception occurred: "+e.getMessage());}
	}
	
	public static void main(String[] args)
	{
		//BankAccount acc=new BankAccountUnlocked("Tyler");
		//BankAccount acc=new BankAccountLocked("Tyler");
		BankAccount acc=new BankAccountSynched("Tyler");
		System.out.println("New account: "+acc+"\nRunning deposits followed by withdrawls that should work out to 0... (each thread runs "+BankRunner.TIMES+" times)");
		BankRunner runner=new BankRunner(acc,4);
		runner.initThreads();
		
		runner.waitForThreads();
		System.out.println("Exiting with account: "+acc);
	}
}
